VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "One Time Pad"
   ClientHeight    =   3795
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9015
   LinkTopic       =   "Form1"
   ScaleHeight     =   3795
   ScaleWidth      =   9015
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDecipher 
      Caption         =   "Decipher"
      Height          =   375
      Left            =   2760
      TabIndex        =   4
      Top             =   2880
      Width           =   855
   End
   Begin VB.CommandButton cmdEncipher 
      Caption         =   "Encipher"
      Height          =   375
      Left            =   2760
      TabIndex        =   3
      Top             =   2400
      Width           =   855
   End
   Begin VB.TextBox txtCiphertext 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1935
      Left            =   3480
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   360
      Width           =   1575
   End
   Begin VB.TextBox txtPad 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1935
      Left            =   1800
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   360
      Width           =   1575
   End
   Begin VB.TextBox txtPlaintext 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1935
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   360
      Width           =   1575
   End
   Begin VB.Label lblCiphertext 
      Alignment       =   2  'Center
      Caption         =   "Ciphertext"
      Height          =   255
      Left            =   3480
      TabIndex        =   7
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label lblPad 
      Alignment       =   2  'Center
      Caption         =   "One Time Pad"
      Height          =   255
      Left            =   1800
      TabIndex        =   6
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label lblPlaintext 
      Alignment       =   2  'Center
      Caption         =   "Plaintext"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Encipher the text using the pad.
Private Function Encipher(ByVal plaintext As String, ByVal pad As String) As String
Const ASC_A = 65

Dim i As Integer
Dim ciphertext As String
Dim ch1 As Integer
Dim ch2 As Integer
Dim ch3 As Integer

    ' Make sure the message is no longer than the pad.
    If Len(plaintext) > Len(pad) Then plaintext = Left$(plaintext, Len(pad))

    ' Encipher.
    For i = 1 To Len(plaintext)
        If i Mod 6 = 0 Then
            ciphertext = ciphertext & " "
        Else
            ch1 = Asc(Mid$(plaintext, i, 1)) - ASC_A
            ch2 = Asc(Mid$(pad, i, 1)) - ASC_A
            ch3 = (ch1 + ch2) Mod 26
            ciphertext = ciphertext & Chr$(ch3 + ASC_A)
        End If
    Next i

    Encipher = ciphertext
End Function
' Decipher the text using the pad.
Private Function Decipher(ByVal ciphertext As String, ByVal pad As String) As String
Const ASC_A = 65

Dim i As Integer
Dim plaintext As String
Dim ch1 As Integer
Dim ch2 As Integer
Dim ch3 As Integer

    ' Make sure the message is no longer than the pad.
    If Len(ciphertext) > Len(pad) Then ciphertext = Left$(ciphertext, Len(pad))

    ' Encipher.
    For i = 1 To Len(ciphertext)
        If i Mod 6 = 0 Then
            plaintext = plaintext & " "
        Else
            ch1 = Asc(Mid$(ciphertext, i, 1)) - ASC_A
            ch2 = Asc(Mid$(pad, i, 1)) - ASC_A
            ch3 = ch1 - ch2
            If ch3 < 0 Then ch3 = ch3 + 26
            plaintext = plaintext & Chr$(ch3 + ASC_A)
        End If
    Next i

    Decipher = plaintext
End Function
' Make all characters capital letters.
Private Function FormatText(ByVal txt As String)
Dim i As Integer
Dim formatted_text As String
Dim ch As String

    For i = 1 To Len(txt)
        ch = UCase$(Mid$(txt, i, 1))
        If ch >= "A" And ch <= "Z" Then
            formatted_text = formatted_text & ch
            If Len(formatted_text) Mod 6 = 5 _
                Then formatted_text = formatted_text & " "
        End If
    Next i

    FormatText = formatted_text
End Function

Private Sub cmdDecipher_Click()
    ' Format the input text.
    txtCiphertext.Text = FormatText(txtCiphertext.Text)
    txtPad.Text = FormatText(txtPad.Text)

    ' Decipher.
    txtPlaintext.Text = Decipher(txtCiphertext.Text, txtPad.Text)
End Sub

Private Sub cmdEncipher_Click()
    ' Format the input text.
    txtPlaintext.Text = FormatText(txtPlaintext.Text)
    txtPad.Text = FormatText(txtPad.Text)

    ' Encipher.
    txtCiphertext.Text = Encipher(txtPlaintext.Text, txtPad.Text)
End Sub
Private Sub Form_Resize()
Dim wid As Single
Dim hgt As Single

    wid = ScaleWidth / 3
    If wid < 120 Then wid = 120
    hgt = ScaleHeight - lblPlaintext.Height - cmdEncipher.Height - 30
    If hgt < 120 Then hgt = 120

    lblPlaintext.Move 0, 0, wid
    lblPad.Move wid, 0, wid
    lblCiphertext.Move 2 * wid, 0, wid

    txtPlaintext.Move 0, lblPad.Height, wid, hgt
    txtPad.Move wid, lblPad.Height, wid, hgt
    txtCiphertext.Move 2 * wid, lblPad.Height, wid, hgt

    cmdEncipher.Move ScaleWidth / 2 - cmdEncipher.Width - 30, txtPad.Top + txtPad.Height + 30
    cmdDecipher.Move ScaleWidth / 2 + 30, txtPad.Top + txtPad.Height + 30
End Sub
